package heron;

import java.awt.*;

import javax.swing.*;
import java.awt.event.*;
import java.math.BigDecimal;
import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.axis.NumberAxis;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.chart.plot.XYPlot;
import org.jfree.chart.renderer.xy.StandardXYItemRenderer;
import org.jfree.data.xy.XYDataset;
import org.jfree.data.xy.XYSeries;
import org.jfree.data.xy.XYSeriesCollection;

public class GUIHeronSqrt extends JFrame implements ActionListener {
	
	private static final long serialVersionUID = 1L;
	JButton button2 =  new JButton("go");   	// go button
	JTextField field1 =  new JTextField(8); 	// area field
	JTextField field2 =  new JTextField(8);     // start value field
	JTextField field3 =  new JTextField(8);		// scale field
	JTextField field4 =  new JTextField(8);		// count field
	JList list1 = new JList();
	JList list2 = new JList();
	JFreeChart chart;
	ChartPanel chartPanel = new ChartPanel(chart);
	
	void buildConstraints(GridBagConstraints gbc, int gx, int gy, int gw, int gh, 
						 int wx, int wy ){
		
		gbc.gridx = gx; 
		gbc.gridy = gy;
		gbc.gridwidth = gw;
		gbc.gridheight = gh;
		gbc.weightx = wx;
		gbc.weighty = wy;
	
	}

	public GUIHeronSqrt(){
		super("HeronSqrt");
		setSize(600, 500);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		GridBagLayout gridbag = new GridBagLayout();
		GridBagConstraints constraints = new GridBagConstraints();
		JPanel pane = new JPanel();
		pane.setLayout(gridbag);
		
		//new button
		buildConstraints(constraints, 0,0,2,1,20,1);
		constraints.fill = GridBagConstraints.CENTER;
		JLabel label =  new JLabel("sqrt root");
		gridbag.setConstraints(label, constraints);
		pane.add(label);
		
		
		//area label
		buildConstraints(constraints, 0,1,1,1,5,1);
		constraints.fill = GridBagConstraints.CENTER;
		JLabel label1 =  new JLabel("area");
		gridbag.setConstraints(label1, constraints);
		pane.add(label1);
		
		//start value label
		buildConstraints(constraints, 0,2,1,1,0,1);
		constraints.fill = GridBagConstraints.CENTER;
		JLabel label2 =  new JLabel("start value");
		gridbag.setConstraints(label2, constraints);
		pane.add(label2);
		
//		scale label
		buildConstraints(constraints, 0,3,1,1,0,1);
		constraints.fill = GridBagConstraints.CENTER;
		JLabel label3 =  new JLabel("scale");
		gridbag.setConstraints(label3, constraints);
		pane.add(label3);
		
//		count label
		buildConstraints(constraints, 0,4,1,1,0,1);
		constraints.fill = GridBagConstraints.CENTER;
		JLabel label4 =  new JLabel("count");
		gridbag.setConstraints(label4, constraints);
		pane.add(label4);
		
	
//		go button
		buildConstraints(constraints, 0,5,2,1,0,1);
		constraints.fill = GridBagConstraints.CENTER;
		button2.addActionListener(this);
		gridbag.setConstraints(button2, constraints);
		pane.add(button2);
		
		
		//area field
		buildConstraints(constraints, 1,1,1,1,15,0);
		constraints.fill = GridBagConstraints.CENTER;
		gridbag.setConstraints(field1, constraints);
		pane.add(field1);
		
		//start value field
		buildConstraints(constraints, 1,2,1,1,0,0);
		constraints.fill = GridBagConstraints.CENTER;
		gridbag.setConstraints(field2, constraints);
		pane.add(field2);
		
		//scale field
		buildConstraints(constraints, 1,3,1,1,0,0);
		constraints.fill = GridBagConstraints.CENTER;
		gridbag.setConstraints(field3, constraints);
		pane.add(field3);
		
//		count field
		buildConstraints(constraints, 1,4,1,1,0,0);
		constraints.fill = GridBagConstraints.CENTER;
		gridbag.setConstraints(field4, constraints);
		pane.add(field4);
		
		//x value label
		buildConstraints(constraints, 2,0,1,3,5,0);
		constraints.fill = GridBagConstraints.CENTER;
		JLabel label5 =  new JLabel("x");
		gridbag.setConstraints(label5, constraints);
		pane.add(label5);
		
		//y value label
		buildConstraints(constraints, 2,3,1,3,0,0);
		constraints.fill = GridBagConstraints.CENTER;
		JLabel label6 =  new JLabel("y");
		gridbag.setConstraints(label6, constraints);
		pane.add(label6);
	
		//x value list
		buildConstraints(constraints, 3,0,1,3,75,0);
		constraints.fill = GridBagConstraints.BOTH;
		list1.setVisibleRowCount(5);
		JScrollPane scroll5 = new JScrollPane(list1, ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED,ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		gridbag.setConstraints(scroll5, constraints);
		pane.add(scroll5);
		
	
		//y value list
		buildConstraints(constraints, 3,3,1,3,75,0);
		constraints.fill = GridBagConstraints.BOTH;
		list2.setVisibleRowCount(5);
		JScrollPane scroll6 = new JScrollPane(list2, ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED,ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		gridbag.setConstraints(scroll6, constraints);
		pane.add(scroll6);
		
//		coordinate plane
		buildConstraints(constraints, 0,6,4,1,100,50);
		chartPanel.setPreferredSize(new java.awt.Dimension(100,100)); 
		gridbag.setConstraints(chartPanel, constraints);
		pane.add(chartPanel);
		
		//Content-Pane
		setContentPane(pane);
		setVisible(true);
	}

	private void calculate(){
		
		double area = Double.parseDouble(field1.getText());
		double startvalue = Double.parseDouble(field2.getText());
		int scale = Integer.parseInt(field3.getText());
		int count = Integer.parseInt(field4.getText());
		BigDecimal heronSqrt[] = HeronSqrt.heronSqrt(startvalue,area,scale,count);
		BigDecimal heronSqrtY[]= HeronSqrt.heronSqrtY(heronSqrt,area,scale,count);
		list1.setListData(heronSqrt);
		list2.setListData(heronSqrtY);
		System.out.println("Scale: " +  heronSqrt[count].scale());
		System.out.println("Check: " + heronSqrt[count].multiply(heronSqrt[count]));
		chart = createChart(createDataset(heronSqrt,heronSqrtY,count));
		chartPanel.setChart(chart);
	}
	
	private XYDataset createDataset(BigDecimal[] x, BigDecimal[] y, int count) {
        XYSeriesCollection collection = new XYSeriesCollection();
        for (int i = 0; i <= count; i++) {
        	XYSeries series = new XYSeries(""+i);
        	System.out.println("count: " +i);
        	series.add(0,(double)new Double(y[i].toString()));
            series.add((double)new Double(x[i].toString()),(double)new Double(y[i].toString()));
            series.add((double)new Double(x[i].toString()),0);
            collection.addSeries(series);
        }
        
        return collection;
    }

    private JFreeChart createChart(XYDataset dataset) {
        JFreeChart chart = ChartFactory.createXYLineChart("Babilonisches Wurzelziehen(Heron)", "x", "y", dataset,
                PlotOrientation.VERTICAL, true, true, false);
        
        XYPlot plot = chart.getXYPlot();
        NumberAxis rangeAxis = (NumberAxis) plot.getRangeAxis();
        rangeAxis.setAutoRange(true);
        rangeAxis.setAutoRangeIncludesZero(true);
        rangeAxis.setAutoRangeStickyZero(true);
        rangeAxis.setAutoRangeIncludesZero(true);
        plot.setRangeAxis(rangeAxis);
        NumberAxis domainAxis = new NumberAxis("x");
        domainAxis.setAutoRangeIncludesZero(true);
        domainAxis.setAutoRangeStickyZero(true);
        domainAxis.setAutoRange(true);
        domainAxis.setAutoRangeIncludesZero(true);
        plot.setDomainAxis(domainAxis);
        StandardXYItemRenderer renderer = new StandardXYItemRenderer();
        renderer.setPlotShapes(true);
        renderer.setShapesFilled(true);
        plot.setRenderer(renderer);
        return chart;
    }
	
	
	public static void main(String[] args){
		GUIHeronSqrt frame = new GUIHeronSqrt();	
	}
	
	public void actionPerformed(ActionEvent evt){
		
		Object src = evt.getSource();
		if (src == button2)
			calculate();
	
	}
}
